package at.ac.uibk.gitsearch.es.model;

import java.util.List;

public class ArtemisExerciseInfo extends ExerciseInfo {

    private Float maxPoints;

    private Float bonusPoints;

    private ExerciseMode mode;

    private Boolean staticCodeAnalysis;

    private Boolean allowOfflineIDE;

    private Boolean allowOnlineEditor;

    private Boolean showTestNamesToStudents;

    private Boolean sequentialTestRuns;

    public ArtemisExerciseInfo() {

    }

    public Float getMaxPoints() {
        return maxPoints;
    }

    public Float getBonusPoints() {
        return bonusPoints;
    }

    public ExerciseMode getMode() {
        return mode;
    }

    public Boolean getStaticCodeAnalysis() {
        return staticCodeAnalysis;
    }

    public Boolean getAllowOfflineIDE() {
        return allowOfflineIDE;
    }

    public Boolean getAllowOnlineEditor() {
        return allowOnlineEditor;
    }

    public Boolean getShowTestNamesToStudents() {
        return showTestNamesToStudents;
    }

    public Boolean getSequentialTestRuns() {
        return sequentialTestRuns;
    }

    public ExerciseInfo getExerciseInfoOnly() {
        ExerciseInfo exerciseInfo = new ExerciseInfo();
        exerciseInfo.setMetadataVersion(this.getMetadataVersion());
        exerciseInfo.setType(this.getType());
        exerciseInfo.setTitle(this.getTitle());
        exerciseInfo.setLicense(this.getLicense());
        if (this.getDescription() != null) {
            exerciseInfo.setDescription(this.getDescription());
        }
        if (this.getKeyword() != null) {
            exerciseInfo.setKeyword(this.getKeyword());
        }
        if (this.getFormat() != null) {
            exerciseInfo.setFormat(this.getFormat());
        }
        if (this.getStructure() != null) {
            exerciseInfo.setStructure(this.getStructure());
        }
        if (this.getProgrammingLanguage() != null) {
            exerciseInfo.setProgrammingLanguage(this.getProgrammingLanguage());
        }
        if (this.getLanguage() != null) {
            exerciseInfo.setLanguage(this.getLanguage());
        }
        if (this.getDifficulty() != null) {
            exerciseInfo.setDifficulty(this.getDifficulty());
        }
        if (this.getCreator() != null) {
            exerciseInfo.setCreator(List.copyOf(this.getCreator()));
        }
        if (this.getContributor() != null) {
            exerciseInfo.setContributor(List.copyOf(this.getContributor()));
        }
        if (this.getSource() != null) {
            exerciseInfo.setSource(this.getSource());
        }
        return exerciseInfo;
    }

    /**
     * Used to merge attributes of ExerciseInfo into an ArtemisExerciseInfo class
     * @param exerciseInfo to merge
     */
    public void appendExerciseInfo(ExerciseInfo exerciseInfo) {
        this.setMetadataVersion(exerciseInfo.getMetadataVersion());
        this.setType(exerciseInfo.getType());
        this.setTitle(exerciseInfo.getTitle());
        this.setLicense(exerciseInfo.getLicense());
        this.setKeyword(exerciseInfo.getKeyword());
        this.setFormat(exerciseInfo.getFormat());
        this.setStructure(exerciseInfo.getStructure());
        this.setProgrammingLanguage(exerciseInfo.getProgrammingLanguage());
        this.setLanguage(exerciseInfo.getLanguage());
        if (exerciseInfo.getCreator() != null) {
            this.setCreator(List.copyOf(exerciseInfo.getCreator()));
        }
        if (exerciseInfo.getContributor() != null) {
            this.setContributor(List.copyOf(exerciseInfo.getContributor()));
        }
        this.setDifficulty(exerciseInfo.getDifficulty());
        this.setSource(exerciseInfo.getSource());
    }

    public enum ExerciseMode {INDIVIDUAL, TEAM};
}
